/*-----------------------------------------------------------------------
 * File: COUNTITM.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* 
 * count the number of subordinate BER objects in a definite
 * length constructed BER object
*/
sint32
BER_CountItems(const uint8 *Octets, uint32 Length)
{
    int result;
    uint32 len;
    for (result = 0; Length > 0; result++) {
        /* Check for constructed indefinite tagging.  Don't count the last 2 bytes if constructed indefinite */
        if (Length == 2 && Octets[0] == 0x00 && Octets[1] == 0x00)
            break;

        len = BER_SizeofObject(Octets);
        if (len > Length) return 0;
        Length -= len;
        Octets += len;
    }
    return result;
}
