/*-----------------------------------------------------------------------
 * File: OUTTAG.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/*
 * output tag for BER/DER
 */
uint32 
BER_OutputTag(      /* return length of copied tag */
    const uint8 *Source,      /* input BER/DER tag */
    uint8 *Octets)      /* output buffer */
{
    uint32 length;
    *Octets++ = *Source;

    length = 1;
    if ((*Source & 31) == 31) {   /* output long tag */
        do {
            *Octets++ = *(++Source);
            length++;
        } while ((*Source & 128) != 0);
    }
    return length;
}
