/*-----------------------------------------------------------------------
 * File: SIZEOF.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* return length of tag + length + contents for BER encoding */
uint32 
BER_SizeofObject(const uint8 *Octets)
{
    uint32 length, headLength;
    sint32 noctets;

    if (!Octets) return 0;

    length = 1;
    /* bypass tag */
    if ((*Octets++ & 31) == 31) { /* long tag */
        while ((*Octets++ & 128) != 0) length++;
        length++;
    }
    /* compute length of length and contents */
    if ((*Octets & 128) == 0) 
        return length + 1 + *Octets;  /* short definite */
    noctets = *Octets++ & 127;
    headLength = noctets + length + 1;
    length = 0;
    if (noctets > 0) {   
        while (noctets-- > 0) length = 256 * length + *Octets++;
        return length + headLength;     /* long definite */
    }
    /* constructed indefinite length */
    while (Octets[0] != 0 || Octets[1] != 0) { 
        noctets = BER_SizeofObject(Octets);
        length += noctets;
        Octets += noctets;
    }
    length += 2;

    return length + headLength;
}
