/*-----------------------------------------------------------------------
 * File: UNLONG2D.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "ber_der.h"

/* 
 * encode an unsigned long into a DER integer at the given memory, 
 * return length in octets 
 */
uint32 
DER_UnlongToDer(
    uint32 Value, 
    uint8 *Octets)
{
    uint32 temp;
    sint16 length;

    temp = 128;  // BER Integers are SIGNED two's complement
    for (length = 1; length < sizeof(uint32); length++) {
        if (Value < temp) break;
        temp = temp * 256;
    }
    *Octets++ = BER_INTEGER;    /* UNIVERSAL, primitive */
    if ((Value & 0x80000000) == 0) {
        *Octets++ = (uint8) length; /* short definite length */
        temp = length + 2;
    } else {
        *Octets++ = (unsigned char)(length + 1);
        temp = length + 3;
        *Octets++ = 0;  /* extra zero byte due to sign bit set */
    }
    while (length > 0) {
        Octets[--length] = (uint8) (Value % 256);
        Value = Value / 256;
    }

    return temp;
}
