/*-----------------------------------------------------------------------
 * File: KEYCONV.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

// Converts BSafe Key Blobs to CSSM Key Blobs and vice versa

CSSM_RETURN
Cryp_BSafeRSAPublicKey_to_CSSMRSAPublicKey(
    uint32                  nModulus,
    uint32                  nPublicKeyUsage,
    uint8                   *pBSafePubKey,
    CSSM_KEY_PTR            pCssmPubKey);

CSSM_RETURN
Cryp_BSafeRSAPrivateKey_to_CSSMRSAPrivateKey(
    uint32                  nModulus,
    uint32                  nPrivateKeyUsage,
    uint8                   *pBSafePriKey,
    CSSM_KEY_PTR            pCssmPriKey);

CSSM_RETURN
Cryp_CSSMRSAPublicKey_to_BSafeRSAPublicKey(
    CSSM_KEY_PTR            pCssmPubKey,
    uint8                   *pBSafePubKey,
    uint32                  *pnBSafePubLen);

CSSM_RETURN
Cryp_CSSMRSAPrivateKey_to_BSafeRSAPrivateKey(
    CSSM_KEY_PTR            pCssmPriKey,
    uint8                   *pBSafePriKey,
    uint32                  *pnBSafePriLen);

CSSM_RETURN
Cryp_BSafeDSAPublicKey_to_CSSMDSAPublicKey(
    uint32                  nModulus,
    uint32                  nPublicKeyUsage,
    uint8                   *pBSafePubKey,
    CSSM_KEY_PTR            pCssmPubKey);

CSSM_RETURN
Cryp_BSafeDSAPrivateKey_to_CSSMDSAPrivateKey(
    uint32                  nModulus,
    uint32                  nPrivateKeyUsage,
    uint8                   *pBSafePriKey,
    CSSM_KEY_PTR            pCssmPriKey);

CSSM_RETURN
Cryp_CSSMDSAPublicKey_to_BSafeDSAPublicKey(
    CSSM_KEY_PTR            pCssmPubKey,
    uint8                   *pBSafePubKey,
    uint32                  *pnBSafePubLen);

CSSM_RETURN
Cryp_CSSMDSAPrivateKey_to_BSafeDSAPrivateKey(
    CSSM_KEY_PTR            pCssmPriKey,
    uint8                   *pBSafePriKey,
    uint32                  *pnBSafePriLen);
