/*-----------------------------------------------------------------------
 * File: PASSTHRU.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 


// suppress warnings in the runtime headers
#ifndef VMS
#pragma warning (disable:4201 4514 4214 4115)
#endif
#ifdef WIN32
#include <windows.h>
#endif
#include <stdio.h>
#ifndef VMS
#pragma warning (default:4201 4514 4214 4115)
#endif

/* CDSA includes */
#include "cssm.h"               /* CSSM types, errors, and APIs */
#include "cssmspi.h"            /* CSSM service provider interface */
#include "cssmtpi.h"            /* CSSM trust policy interface */

/* Intel includes */
#include "maf_include.h"

/* local includes */
#include "inx509tp.h"           /* func and data definitions 
                                   specific to this module */
#include "api_shim.h"

#include <cssmMemTrack.h>

/*---------------------------------------------------------------
 *
 * Name: TP_PassThrough
 *
 * Description:
 *   Module specific functionality that is unaccessable through the
 *   TP API.  
 *
 * Parameters: 
 *   TPHandle (input)       - Handle of the TP module
 *   CLHandle (input)       - Handle of the CL module
 *   CSPHandle (input)      - Handle of the CSP module
 *   DBList (input)         - List of DLDBHandles to databases
 *   PassThroughId (input)  - Identifier that describes the 
 *                            function
 *   InputParams (input)    - Input data for the function
 *
 * Returns:
 *   NULL                   - unable to perform module specific function
 *   non NULL               - result from performing the module specific function
 *
 *-------------------------------------------------------------*/
CSSM_RETURN CSSMAPI 
TP_PassThrough( CSSM_TP_HANDLE TPHandle, 
                CSSM_CL_HANDLE CLHandle, 
                CSSM_CC_HANDLE CCHandle, 
                const CSSM_DL_DB_LIST *DBList,
                uint32 PassThroughId,
                const void *InputParams,
                void **OutputParams)
{
  /* unused parameters */
  TPHandle;
  CLHandle;
  CCHandle;
  DBList;
  PassThroughId;
  InputParams;
  OutputParams;

  return( CSSMERR_TP_FUNCTION_NOT_IMPLEMENTED );
}
