/*-----------------------------------------------------------------------
 * File: COMMON.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#define EXPORT_KEY 1
#define INTEGRITY_KEY 2
#define MAX_CERTS 5
#define MAX_ISSUER_INFO_BUFFER 1024

#define EXPORT_KEY 1
#define INTEGRITY_KEY 2

CSSM_RETURN cssm_FreeManifestSections( ISL_MANIFEST_SECTION_PTR* ManifestSectionPtrArr, 
                                      uint32 NumSections);
CSSM_RETURN cssm_FreeVerifiedCredentials( ISL_VERIFIED_MODULE_PTR* VerifiedModulePtrArr, 
                                      uint32 NumSections);

int cssm_GetExportRootNames(ISL_CALLOUT_DATA *Name);
int cssm_GetIntegrityRootNames(ISL_CALLOUT_DATA * Name);
ISL_VERIFIED_MODULE_PTR*
cssm_VerifyCredentialsAndLoadModules(ISL_CONST_DATA ModuleCredential,
        ISL_CONST_DATA ModuleSearchPath,uint32 KeyType,CSSM_BOOL bLoadModule,
        uint32 *NumSections, CSSM_API_MEMORY_FUNCS_PTR MemoryFuncs);

ISL_MANIFEST_SECTION_PTR*
cssm_VerifyCredentials(ISL_CONST_DATA ModuleCredential, ISL_CONST_DATA ModuleSearchPath,
        uint32 KeyType, uint32 *NumSections, CSSM_API_MEMORY_FUNCS_PTR MemoryFuncs);
ISL_VERIFIED_MODULE_PTR*
cssm_VerifyLoadedOrLoadAllModules( ISL_MANIFEST_SECTION_PTR* ManifestSection,uint32* NumSections,
                                   CSSM_BOOL bLoadModule, CSSM_API_MEMORY_FUNCS_PTR MemoryFuncs);
int cssm_GetExportRootKeys(ISL_CALLOUT_DATA *Name);
int cssm_GetIntegrityRootKeys(ISL_CALLOUT_DATA *Name);
