/*-----------------------------------------------------------------------
 * File: DUMMYMULTICSPI.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "maf_include.h"
#include "dmytstemmaddinfnspi.h"
#include "dmytstemmaddinfns_err.h"

/* Define each SPI function.
 */
CSSM_RETURN CSSMSPI DummyTest_Passthru(
                    CSSM_MODULE_HANDLE Handle,
                    CSSM_SERVICE_TYPE ServiceType )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, Handle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSM_OK;
}

CSSM_RETURN CSSMSPI DummyTest_Passthru1(
                    CSSM_MODULE_HANDLE Handle,
                    CSSM_SERVICE_TYPE ServiceType )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, Handle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSM_OK;
}



/* Define the attach function.
 */
CSSM_RETURN dummytest_emmaddin_ModuleAttach(
                   CSSM_MODULE_FUNCS_PTR *FuncTbl )
{
    static CSSM_MODULE_FUNCS FunctionList;
    static CSSM_SPI_EMMADDIN_FUNCS Functions;
    if (!FuncTbl)
    {
        return CSSMERR_CSSM_INVALID_POINTER;
    }
    FunctionList.ServiceType = CSSM_SERVICE_EMM_DUMMY_TEST;
    FunctionList.NumberOfServiceFuncs = sizeof(CSSM_SPI_EMMADDIN_FUNCS) /
                                          sizeof(CSSM_PROC_ADDR);

    FunctionList.ServiceFuncs = (CSSM_PROC_ADDR*)&Functions;
    Functions.Passthru = DummyTest_Passthru;
    Functions.Passthru1 = DummyTest_Passthru1;
    *FuncTbl = &FunctionList;
    return CSSM_OK;
}
