/*-----------------------------------------------------------------------
 * File: dummyhrsaddini.c
 *
 * Copyright (c) 1999-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "precomp.h"

/* Define each SPI function.
 */
CSSM_RETURN CSSMHRSI HRS_FreeBIRHandle(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_BIR_HANDLE BIRHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_FREE_BIRHANDLE;
}

CSSM_RETURN CSSMHRSI HRS_GetBIRFromHandle(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_BIR_HANDLE BIRHandle,
                    CSSM_HRS_BIR_PTR *BIR )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_GET_BIRFROM_HANDLE;
}

CSSM_RETURN CSSMHRSI HRS_GetHeaderFromHandle(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_BIR_HANDLE BIRHandle,
                    CSSM_HRS_BIR_HEADER_PTR Header )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_GET_HEADER_FROM_HANDLE;
}

CSSM_RETURN CSSMHRSI HRS_EnableEvents(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_MODULE_EVENT_MASK *Events )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_ENABLE_EVENTS;
}

CSSM_RETURN CSSMHRSI HRS_SetGUICallbacks(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_GUI_STREAMING_CALLBACK GuiStreamingCallback,
                    void *GuiStreamingCallbackCtx,
                    CSSM_HRS_GUI_STATE_CALLBACK GuiStateCallback,
                    void *GuiStateCallbackCtx )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_SET_GUICALLBACKS;
}

CSSM_RETURN CSSMHRSI HRS_CancelGUICallbacks(
                    CSSM_HANDLE ModuleHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_CANCEL_GUICALLBACKS;
}

CSSM_RETURN CSSMHRSI HRS_SetStreamCallback(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_STREAM_CALLBACK StreamCallback,
                    void *StreamCallbackCtx )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_SET_STREAM_CALLBACK;
}

CSSM_RETURN CSSMHRSI HRS_CancelStreamCallbacks(
                    CSSM_HANDLE ModuleHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_CANCEL_STREAM_CALLBACKS;
}

CSSM_RETURN CSSMHRSI HRS_StreamInputOutput(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_DATA_PTR InMessage,
                    CSSM_DATA_PTR OutMessage )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_STREAM_INPUT_OUTPUT;
}

CSSM_RETURN CSSMHRSI HRS_Capture(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_BIR_PURPOSE Purpose,
                    CSSM_HRS_BIR_HANDLE_PTR CapturedBIR,
                    sint32 Timeout,
                    CSSM_HRS_BIR_HANDLE_PTR AuditData )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_CAPTURE;
}

CSSM_RETURN CSSMHRSI HRS_CreateTemplate(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_INPUT_BIR *CapturedBIR,
                    const CSSM_HRS_INPUT_BIR *StoredTemplate,
                    CSSM_HRS_BIR_HANDLE_PTR NewTemplate,
                    const CSSM_DATA *Payload )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_CREATE_TEMPLATE;
}

CSSM_RETURN CSSMHRSI HRS_Process(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_INPUT_BIR *CapturedBIR,
                    CSSM_HRS_BIR_HANDLE_PTR ProcessedBIR )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_PROCESS;
}

CSSM_RETURN CSSMHRSI HRS_VerifyMatch(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_FAR *MaxFARRequested,
                    const CSSM_HRS_FRR *MaxFRRRequested,
                    const CSSM_BOOL *FARPrecedence,
                    const CSSM_HRS_INPUT_BIR *ProcessedBIR,
                    const CSSM_HRS_INPUT_BIR *StoredTemplate,
                    CSSM_HRS_BIR_HANDLE *AdaptedBIR,
                    CSSM_BOOL *Result,
                    CSSM_HRS_FAR_PTR FARAchieved,
                    CSSM_HRS_FRR_PTR FRRAchieved,
                    CSSM_DATA_PTR *Payload )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_VERIFY_MATCH;
}

CSSM_RETURN CSSMHRSI HRS_IdentifyMatch(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_FAR *MaxFARRequested,
                    const CSSM_HRS_FRR *MaxFRRRequested,
                    const CSSM_BOOL *FARPrecedence,
                    const CSSM_HRS_INPUT_BIR *ProcessedBIR,
                    const CSSM_HRS_IDENTIFY_POPULATION *Population,
                    CSSM_BOOL Binning,
                    uint32 MaxNumberOfResults,
                    uint32 *NumberOfResults,
                    CSSM_HRS_CANDIDATE_ARRAY_PTR *Candidates,
                    sint32 Timeout )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_IDENTIFY_MATCH;
}

CSSM_RETURN CSSMHRSI HRS_Enroll(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_BIR_PURPOSE Purpose,
                    const CSSM_HRS_INPUT_BIR *StoredTemplate,
                    CSSM_HRS_BIR_HANDLE_PTR NewTemplate,
                    const CSSM_DATA *Payload,
                    sint32 Timeout,
                    CSSM_HRS_BIR_HANDLE_PTR AuditData )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_ENROLL;
}

CSSM_RETURN CSSMHRSI HRS_Verify(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_FAR *MaxFARRequested,
                    const CSSM_HRS_FRR *MaxFRRRequested,
                    const CSSM_BOOL *FARPrecedence,
                    const CSSM_HRS_INPUT_BIR *StoredTemplate,
                    CSSM_HRS_BIR_HANDLE_PTR AdaptedBIR,
                    CSSM_BOOL *Result,
                    CSSM_HRS_FAR_PTR FARAchieved,
                    CSSM_HRS_FRR_PTR FRRAchieved,
                    CSSM_DATA_PTR *Payload,
                    sint32 Timeout,
                    CSSM_HRS_BIR_HANDLE_PTR AuditData )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_VERIFY;
}

CSSM_RETURN CSSMHRSI HRS_Identify(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_FAR *MaxFARRequested,
                    const CSSM_HRS_FRR *MaxFRRRequested,
                    const CSSM_BOOL *FARPrecedence,
                    const CSSM_HRS_INPUT_BIR *ProcessedBIR,
                    const CSSM_HRS_IDENTIFY_POPULATION *Population,
                    CSSM_BOOL Binning,
                    uint32 MaxNumberOfResults,
                    uint32 *NumberOfResults,
                    CSSM_HRS_CANDIDATE_ARRAY_PTR *Candidates,
                    sint32 Timeout,
                    CSSM_HRS_BIR_HANDLE_PTR AuditData )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_IDENTIFY;
}

CSSM_RETURN CSSMHRSI HRS_Import(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_DATA *InputData,
                    CSSM_HRS_BIR_BIOMETRIC_DATA_FORMAT InputFormat,
                    CSSM_HRS_BIR_PURPOSE Purpose,
                    CSSM_HRS_BIR_HANDLE_PTR ConstructedBIR )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_IMPORT;
}

CSSM_RETURN CSSMHRSI HRS_SetPowerMode(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_POWER_MODE PowerMode )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_SET_POWER_MODE;
}

CSSM_RETURN CSSMHRSI HRS_DbOpen(
                    CSSM_HANDLE ModuleHandle,
                    const uint8 *DbName,
                    CSSM_HRS_DB_ACCESS_TYPE AccessRequest,
                    CSSM_HRS_DB_HANDLE_PTR DbHandle,
                    CSSM_HRS_DB_CURSOR_PTR Cursor )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_OPEN;
}

CSSM_RETURN CSSMHRSI HRS_DbClose(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_HANDLE DbHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_CLOSE;
}

CSSM_RETURN CSSMHRSI HRS_DbCreate(
                    CSSM_HANDLE ModuleHandle,
                    const uint8 *DbName,
                    CSSM_HRS_DB_ACCESS_TYPE AccessRequest,
                    CSSM_HRS_DB_HANDLE_PTR DbHandle )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_CREATE;
}

CSSM_RETURN CSSMHRSI HRS_DbDelete(
                    CSSM_HANDLE ModuleHandle,
                    const uint8 *DbName )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_DELETE;
}

CSSM_RETURN CSSMHRSI HRS_DbSetCursor(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_HANDLE DbHandle,
                    const CSSM_GUID *KeyValue,
                    CSSM_HRS_DB_CURSOR_PTR Cursor )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_SET_CURSOR;
}

CSSM_RETURN CSSMHRSI HRS_DbFreeCursor(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_CURSOR_PTR Cursor )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_FREE_CURSOR;
}

CSSM_RETURN CSSMHRSI HRS_DbStoreBIR(
                    CSSM_HANDLE ModuleHandle,
                    const CSSM_HRS_INPUT_BIR *BIRToStore,
                    CSSM_HRS_DB_HANDLE DbHandle,
                    CSSM_GUID_PTR Uuid )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_STORE_BIR;
}

CSSM_RETURN CSSMHRSI HRS_DbGetBIR(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_HANDLE DbHandle,
                    const CSSM_GUID *KeyValue,
                    CSSM_HRS_BIR_HANDLE_PTR RetrievedBIR,
                    CSSM_HRS_DB_CURSOR_PTR Cursor )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_GET_BIR;
}

CSSM_RETURN CSSMHRSI HRS_DbGetNextBIR(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_CURSOR_PTR Cursor,
                    CSSM_HRS_BIR_HANDLE_PTR RetievedBIR,
                    CSSM_GUID_PTR Uuid )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_GET_NEXT_BIR;
}

CSSM_RETURN CSSMHRSI HRS_DbQueryBIR(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_HANDLE DbHandle,
                    const CSSM_HRS_INPUT_BIR *BIRToQuery,
                    CSSM_GUID_PTR Uuid )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_QUERY_BIR;
}

CSSM_RETURN CSSMHRSI HRS_DbDeleteBIR(
                    CSSM_HANDLE ModuleHandle,
                    CSSM_HRS_DB_HANDLE DbHandle,
                    const CSSM_GUID *KeyValue )
{
    CSSM_RETURN ret = CSSM_OK;
    void *pAddinContext = NULL;
    ADDIN_SPI_BEGIN(ret, ModuleHandle, pAddinContext);
    if (ret != CSSM_OK) return ret;
    Addin_SPIEnd(pAddinContext);
    return CSSMERR_HRS_DB_DELETE_BIR;
}


/* Define the attach function.
 */
CSSM_RETURN HRS_ModuleAttach(
                   CSSM_MODULE_FUNCS_PTR *FuncTbl )
{
    static CSSM_MODULE_FUNCS FunctionList;
    static CSSM_SPI_HRS_FUNCS Functions;
    if (!FuncTbl)
    {
        return CSSMERR_CSSM_INVALID_POINTER;
    }
    FunctionList.ServiceType = CSSM_SERVICE_HRS;
    FunctionList.NumberOfServiceFuncs = sizeof(CSSM_SPI_HRS_FUNCS) /
    sizeof(
    CSSM_PROC_ADDR );
    FunctionList.ServiceFuncs = (CSSM_PROC_ADDR*)&Functions;
    Functions.FreeBIRHandle = HRS_FreeBIRHandle;
    Functions.GetBIRFromHandle = HRS_GetBIRFromHandle;
    Functions.GetHeaderFromHandle = HRS_GetHeaderFromHandle;
    Functions.EnableEvents = HRS_EnableEvents;
    Functions.SetGUICallbacks = HRS_SetGUICallbacks;
    Functions.CancelGUICallbacks = HRS_CancelGUICallbacks;
    Functions.SetStreamCallback = HRS_SetStreamCallback;
    Functions.CancelStreamCallbacks = HRS_CancelStreamCallbacks;
    Functions.StreamInputOutput = HRS_StreamInputOutput;
    Functions.Capture = HRS_Capture;
    Functions.CreateTemplate = HRS_CreateTemplate;
    Functions.Process = HRS_Process;
    Functions.VerifyMatch = HRS_VerifyMatch;
    Functions.IdentifyMatch = HRS_IdentifyMatch;
    Functions.Enroll = HRS_Enroll;
    Functions.Verify = HRS_Verify;
    Functions.Identify = HRS_Identify;
    Functions.Import = HRS_Import;
    Functions.SetPowerMode = HRS_SetPowerMode;
    Functions.DbOpen = HRS_DbOpen;
    Functions.DbClose = HRS_DbClose;
    Functions.DbCreate = HRS_DbCreate;
    Functions.DbDelete = HRS_DbDelete;
    Functions.DbSetCursor = HRS_DbSetCursor;
    Functions.DbFreeCursor = HRS_DbFreeCursor;
    Functions.DbStoreBIR = HRS_DbStoreBIR;
    Functions.DbGetBIR = HRS_DbGetBIR;
    Functions.DbGetNextBIR = HRS_DbGetNextBIR;
    Functions.DbQueryBIR = HRS_DbQueryBIR;
    Functions.DbDeleteBIR = HRS_DbDeleteBIR;
    *FuncTbl = &FunctionList;
    return CSSM_OK;
}
