/*-----------------------------------------------------------------------
 * File: MEF_INTEG.H
 *
 * Copyright (c) 2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _MEF_INTEG_H_
#define _MEF_INTEG_H_



typedef enum mef_module_type
{
    MEF_MT_CSSM,
    MEF_MT_EMM,
    MEF_MT_OTHER
}
MEF_MODULE_TYPE, *MEF_MODULE_TYPE_PTR;



/************************************************************************/
/* These functions are only to be called from DllMain, _init()/_fini(), */
/* or their equivalents in other OS's.                                  */
/************************************************************************/

CSSM_RETURN
mef_InitIntegrity();

CSSM_RETURN
mef_FiniIntegrity();

/************************************************************************/


CSSM_RETURN
mef_SelfIntegrityCheck();


CSSM_RETURN
mef_SelfIntegrityClean();


CSSM_RETURN
mef_VerifyCSSM(const CSSM_GUID *CssmGuid,
               CSSM_PROC_ADDR CssmRetAddress);


CSSM_RETURN
mef_CleanVerifiedCSSM(CSSM_PROC_ADDR CssmRetAddress);


CSSM_RETURN
mef_VerifyCallerIsCSSM(CSSM_PROC_ADDR CssmRetAddress);


CSSM_RETURN
mef_LocateProcAddrInSelf(CSSM_FUNC_NAME_ADDR_PTR FuncNameAddrPtr,
                         uint32 NumOfFuncNameAddr);


#ifdef ISL_INCLUDED

CSSM_RETURN
mef_VerifyModule(const CSSM_GUID *Guid,
                 const CSSM_DATA *Credential,
                 const CSSM_DATA *ModuleName,
                 const CSSM_DATA *ModulePath,
                 CSSM_KEY_HIERARCHY KeyHierarchy,
                 MEF_MODULE_TYPE ModuleType,
                 ISL_VERIFIED_MODULE_PTR** tempVerModPtrArr,
                 uint32 *tempNumCreds);

#endif /* ISL_INCLUDED */


#endif /*_MEF_INTEGRITY_H_*/
