/*-----------------------------------------------------------------------
 * File: EMM_MDS.H
 *
 * Copyright (c) 1999-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _EMM_MDS_H_
#define _EMM_MDS_H_

#ifndef _CSSMTYPE_H
#error $/inc/cssmtype.h must be included before this file
#endif

#ifdef __cplusplus
extern "C" {
#endif


/************************************************************************/
/* These functions are only to be called from DllMain, _init()/_fini(), */
/* or their equivalents in other OS's.                                  */
/************************************************************************/

CSSM_RETURN
mef_InitMDSShim();

CSSM_RETURN
mef_FiniMDSShim();

/************************************************************************/


CSSM_RETURN
mef_MDSInit();


CSSM_RETURN
mef_MDSTerm();


CSSM_RETURN
mef_MDSGetCredentialInfo(const CSSM_GUID *pGuid,
                         CSSM_DB_RECORDTYPE Schema,
                         CSSM_DATA *Credential,
                         CSSM_DATA *ModuleName,
                         CSSM_DATA *ModulePath);


CSSM_RETURN
mef_MDSReleaseCredentialInfo(CSSM_DATA *Credential,
                             CSSM_DATA *ModuleName,
                             CSSM_DATA *ModulePath);


#define MEF_PRINTABLE_GUID_LENGTH   40

void
mef_GUIDToStr(const CSSM_GUID *GUID,
              char *ID);


#ifdef __cplusplus
}
#endif

#endif /* #ifndef _EMM_MDS_H_ */
