/*-----------------------------------------------------------------------
 * File: ACM_ACI.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef __ACM_ACI_H__
#define __ACM_ACI_H__


/* AC functions */
CSSM_RETURN CSSMAPI 
ACM_AuthCompute(CSSM_AC_HANDLE ACHandle,
                const CSSM_TUPLEGROUP *BaseAuthorizations,
                const CSSM_TUPLEGROUP *Credentials,
                uint32 NumberOfRequestors,
                const CSSM_LIST *Requestors,
                const CSSM_LIST *RequestedAuthorizationPeriod,
                const CSSM_LIST *RequestedAuthorization,
                CSSM_TUPLEGROUP_PTR AuthorizationResult);



CSSM_RETURN CSSMAPI 
ACM_PassThrough(CSSM_AC_HANDLE ACHandle, 
                CSSM_TP_HANDLE TPHandle, 
                CSSM_CL_HANDLE CLHandle, 
                CSSM_CC_HANDLE CCHandle, 
                const CSSM_DL_DB_LIST *DBList,
                uint32 PassThroughId, 
                const void * InputParams,
                void **OutputParams);


/* AC functions */
CSSM_RETURN CSSMACI 
AC_AuthCompute(CSSM_AC_HANDLE ACHandle,
                const CSSM_TUPLEGROUP *BaseAuthorizations,
                const CSSM_TUPLEGROUP *Credentials,
                uint32 NumberOfRequestors,
                const CSSM_LIST *Requestors,
                const CSSM_LIST *RequestedAuthorizationPeriod,
                const CSSM_LIST *RequestedAuthorization,
                CSSM_TUPLEGROUP_PTR AuthorizationResult);



CSSM_RETURN CSSMACI 
AC_PassThrough(CSSM_AC_HANDLE ACHandle, 
                CSSM_TP_HANDLE TPHandle, 
                CSSM_CL_HANDLE CLHandle, 
                CSSM_CC_HANDLE CCHandle, 
                const CSSM_DL_DB_LIST *DBList,
                uint32 PassThroughId, 
                const void * InputParams,
                void **OutputParams);


#endif
