/*-----------------------------------------------------------------------
 * File: HMACSHA1.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Implements the HMAC-SHA1 construct using EICL primitives */

#ifndef __HMACSHA1_H__
#define __HMACSHA1_H__

/* Check to see that all required headers have been included beforehand */
#ifndef _EICL_INCLUDE_
#error eicl.h must be included before this file
#endif

#define HMAC_SHA1_BLOCK_SIZE    (64)
#define HMAC_SHA1_HASH_LENGTH   (sizeof(EICLSHADigest))

typedef struct hmac_sha1_context
{
    EICLByte kIpad[HMAC_SHA1_BLOCK_SIZE];
    EICLByte kOpad[HMAC_SHA1_BLOCK_SIZE];
    EICLSHAState ShaState;
}
HMAC_SHA1_CONTEXT;

CSSM_RETURN CSSMAPI HMAC_SHA1_Begin(
                        HMAC_SHA1_CONTEXT *pContext,
                        const CSSM_DATA *Key );

CSSM_RETURN CSSMAPI HMAC_SHA1_Update(
                        HMAC_SHA1_CONTEXT *pContext,
                        const CSSM_DATA *Data );

CSSM_RETURN CSSMAPI HMAC_SHA1_End(
                        HMAC_SHA1_CONTEXT *pContext,
                        CSSM_DATA *Result );

#endif /* ifndef __HMACSHA1_H__ */
