/*-----------------------------------------------------------------------
 * File: PKCS5V2.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Implements the PKCS #5 v2.0 PBKD2 key derivation mechanism. */

#ifndef __PKCS5V2_H__
#define __PKCS5V2_H__

/* Check to see that all required headers have been included beforehand */
#ifndef _EICL_INCLUDE_
#error eicl.h must be included before this file
#endif

#ifndef __HMACSHA1_H__
#error hmacsha1.h must be included before this file
#endif

CSSM_RETURN CSSMAPI PKCS5_v2_PBKD2_HMAC_SHA1(
                        const CSSM_DATA *Password,
                        const CSSM_DATA *Salt,
                        uint32 DataLength,
                        uint32 Iterations,
                        uint8 *DataBuf );

#endif /* ifndef __PKCS5V2_H__ */
