/*-----------------------------------------------------------------------
 * File: CHALLENGE.C
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "maf_include.h"

CSSM_BOOL CSSMAPI MAF_CredIsResolvableByChallenge(
                        const CSSM_ACCESS_CREDENTIALS *pAccessCred )
{
    CSSM_BOOL rv = CSSM_TRUE;
    CSSM_ACCESS_CREDENTIALS TempCredentials;

    /* Clear the temporary credentials used as a "blank" comparison */
    memset( &TempCredentials, 0, sizeof(TempCredentials) );

    /* See if everything except "Tag" and callback and callback context
     * are NULL.
     */
    if ( memcmp( &TempCredentials.BaseCerts,
                 &pAccessCred->BaseCerts,
                 sizeof(TempCredentials.BaseCerts) ) ||
         memcmp( &TempCredentials.Samples,
                 &pAccessCred->Samples,
                 sizeof(TempCredentials.Samples) ) )
    {
        rv = CSSM_FALSE;
    }
    /* Make sure the function pointer is valid */
    else if ( port_IsBadCodePtr( (CSSM_PROC_ADDR)pAccessCred->Callback ) )
    {
        rv = CSSM_FALSE;
    }

    return rv;
}
