/***************************************************************************/
/* clookup.c                                                               */
/*                                                                         */
/* The lookup function, generated by genlookup, but edited to use          */
/* CSSM_WORDID__UNK_ and to change calling sequence slightly.              */
/***************************************************************************/

#include "cssmtype.h"
#include "addlwords.h"
#include "compare.h"

static int lookup( uint8 *x, uint32 xl )
{
    switch ( compare( x, xl, "ndr" ) ) {
    case LESSER:
      switch ( compare( x, xl, "e" ) ) {
      case LESSER:
        switch ( compare( x, xl, "date" ) ) {
        case LESSER:
          switch ( compare( x, xl, "biometric" ) ) {
          case LESSER:
            switch ( compare( x, xl, "and" ) ) {
            case LESSER:
              switch ( compare( x, xl, "acl" ) ) {
              case LESSER:
                switch ( compare( x, xl, "a" ) ) {
                case LESSER:
                  switch ( compare( x, xl, "*" ) ) {
                  case LESSER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  case EQUAL:  return ( CSSM_WORDID__STAR_ ) ;
                  case GREATER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  } /* compare( x, xl, "*" ) */
                case EQUAL:  return ( CSSM_WORDID_A ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "a" ) */
              case EQUAL:  return ( CSSM_WORDID_ACL ) ;
              case GREATER:
                switch ( compare( x, xl, "alpha" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_ALPHA ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "alpha" ) */
              } /* compare( x, xl, "acl" ) */
            case EQUAL:  return ( CSSM_WORDID_AND ) ;
            case GREATER:
              switch ( compare( x, xl, "ber" ) ) {
              case LESSER:
                switch ( compare( x, xl, "b" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_B ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "b" ) */
              case EQUAL:  return ( CSSM_WORDID_BER ) ;
              case GREATER:
                switch ( compare( x, xl, "binary" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_BINARY ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "binary" ) */
              } /* compare( x, xl, "ber" ) */
            } /* compare( x, xl, "and" ) */
          case EQUAL:  return ( CSSM_WORDID_BIOMETRIC ) ;
          case GREATER:
            switch ( compare( x, xl, "comment" ) ) {
            case LESSER:
              switch ( compare( x, xl, "canceled" ) ) {
              case LESSER:
                switch ( compare( x, xl, "c" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_C ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "c" ) */
              case EQUAL:  return ( CSSM_WORDID_CANCELED ) ;
              case GREATER:
                switch ( compare( x, xl, "cert" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_CERT ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "cert" ) */
              } /* compare( x, xl, "canceled" ) */
            case EQUAL:  return ( CSSM_WORDID_COMMENT ) ;
            case GREATER:
              switch ( compare( x, xl, "custom" ) ) {
              case LESSER:
                switch ( compare( x, xl, "crl" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_CRL ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "crl" ) */
              case EQUAL:  return ( CSSM_WORDID_CUSTOM ) ;
              case GREATER:
                switch ( compare( x, xl, "d" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_D ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "d" ) */
              } /* compare( x, xl, "custom" ) */
            } /* compare( x, xl, "comment" ) */
          } /* compare( x, xl, "biometric" ) */
        case EQUAL:  return ( CSSM_WORDID_DATE ) ;
        case GREATER:
          switch ( compare( x, xl, "delete" ) ) {
          case LESSER:
            switch ( compare( x, xl, "db-read" ) ) {
            case LESSER:
              switch ( compare( x, xl, "db-insert" ) ) {
              case LESSER:
                switch ( compare( x, xl, "db-exec-stored-query" ) ) {
                case LESSER:
                  switch ( compare( x, xl, "db-delete" ) ) {
                  case LESSER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  case EQUAL:  return ( CSSM_WORDID_DB_DELETE ) ;
                  case GREATER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  } /* compare( x, xl, "db-delete" ) */
                case EQUAL:  return ( CSSM_WORDID_DB_EXEC_STORED_QUERY ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "db-exec-stored-query" ) */
              case EQUAL:  return ( CSSM_WORDID_DB_INSERT ) ;
              case GREATER:
                switch ( compare( x, xl, "db-modify" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DB_MODIFY ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "db-modify" ) */
              } /* compare( x, xl, "db-insert" ) */
            case EQUAL:  return ( CSSM_WORDID_DB_READ ) ;
            case GREATER:
              switch ( compare( x, xl, "dbs-delete" ) ) {
              case LESSER:
                switch ( compare( x, xl, "dbs-create" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DBS_CREATE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "dbs-create" ) */
              case EQUAL:  return ( CSSM_WORDID_DBS_DELETE ) ;
              case GREATER:
                switch ( compare( x, xl, "decrypt" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DECRYPT ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "decrypt" ) */
              } /* compare( x, xl, "dbs-delete" ) */
            } /* compare( x, xl, "db-read" ) */
          case EQUAL:  return ( CSSM_WORDID_DELETE ) ;
          case GREATER:
            switch ( compare( x, xl, "display" ) ) {
            case LESSER:
              switch ( compare( x, xl, "der" ) ) {
              case LESSER:
                switch ( compare( x, xl, "delta-crl" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DELTA_CRL ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "delta-crl" ) */
              case EQUAL:  return ( CSSM_WORDID_DER ) ;
              case GREATER:
                switch ( compare( x, xl, "derive" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DERIVE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "derive" ) */
              } /* compare( x, xl, "der" ) */
            case EQUAL:  return ( CSSM_WORDID_DISPLAY ) ;
            case GREATER:
              switch ( compare( x, xl, "dsa" ) ) {
              case LESSER:
                switch ( compare( x, xl, "do" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DO ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "do" ) */
              case EQUAL:  return ( CSSM_WORDID_DSA ) ;
              case GREATER:
                switch ( compare( x, xl, "dsa-sha1" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_DSA_SHA1 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "dsa-sha1" ) */
              } /* compare( x, xl, "dsa" ) */
            } /* compare( x, xl, "display" ) */
          } /* compare( x, xl, "delete" ) */
        } /* compare( x, xl, "date" ) */
      case EQUAL:  return ( CSSM_WORDID_E ) ;
      case GREATER:
        switch ( compare( x, xl, "issuer-info" ) ) {
        case LESSER:
          switch ( compare( x, xl, "hash" ) ) {
          case LESSER:
            switch ( compare( x, xl, "export-wrapped" ) ) {
            case LESSER:
              switch ( compare( x, xl, "entry" ) ) {
              case LESSER:
                switch ( compare( x, xl, "encrypt" ) ) {
                case LESSER:
                  switch ( compare( x, xl, "elgamal" ) ) {
                  case LESSER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  case EQUAL:  return ( CSSM_WORDID_ELGAMAL ) ;
                  case GREATER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  } /* compare( x, xl, "elgamal" ) */
                case EQUAL:  return ( CSSM_WORDID_ENCRYPT ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "encrypt" ) */
              case EQUAL:  return ( CSSM_WORDID_ENTRY ) ;
              case GREATER:
                switch ( compare( x, xl, "export-clear" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_EXPORT_CLEAR ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "export-clear" ) */
              } /* compare( x, xl, "entry" ) */
            case EQUAL:  return ( CSSM_WORDID_EXPORT_WRAPPED ) ;
            case GREATER:
              switch ( compare( x, xl, "ge" ) ) {
              case LESSER:
                switch ( compare( x, xl, "g" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_G ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "g" ) */
              case EQUAL:  return ( CSSM_WORDID_GE ) ;
              case GREATER:
                switch ( compare( x, xl, "genkey" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_GENKEY ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "genkey" ) */
              } /* compare( x, xl, "ge" ) */
            } /* compare( x, xl, "export-wrapped" ) */
          case EQUAL:  return ( CSSM_WORDID_HASH ) ;
          case GREATER:
            switch ( compare( x, xl, "import-clear" ) ) {
            case LESSER:
              switch ( compare( x, xl, "haval" ) ) {
              case LESSER:
                switch ( compare( x, xl, "hashed-password" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_HASHED_PASSWORD ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "hashed-password" ) */
              case EQUAL:  return ( CSSM_WORDID_HAVAL ) ;
              case GREATER:
                switch ( compare( x, xl, "ibchash" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_IBCHASH ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "ibchash" ) */
              } /* compare( x, xl, "haval" ) */
            case EQUAL:  return ( CSSM_WORDID_IMPORT_CLEAR ) ;
            case GREATER:
              switch ( compare( x, xl, "intel" ) ) {
              case LESSER:
                switch ( compare( x, xl, "import-wrapped" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_IMPORT_WRAPPED ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "import-wrapped" ) */
              case EQUAL:  return ( CSSM_WORDID_INTEL ) ;
              case GREATER:
                switch ( compare( x, xl, "issuer" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_ISSUER ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "issuer" ) */
              } /* compare( x, xl, "intel" ) */
            } /* compare( x, xl, "import-clear" ) */
          } /* compare( x, xl, "hash" ) */
        case EQUAL:  return ( CSSM_WORDID_ISSUER_INFO ) ;
        case GREATER:
          switch ( compare( x, xl, "mac" ) ) {
          case LESSER:
            switch ( compare( x, xl, "l" ) ) {
            case LESSER:
              switch ( compare( x, xl, "kea" ) ) {
              case LESSER:
                switch ( compare( x, xl, "k-of-n" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_K_OF_N ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "k-of-n" ) */
              case EQUAL:  return ( CSSM_WORDID_KEA ) ;
              case GREATER:
                switch ( compare( x, xl, "keyholder" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_KEYHOLDER ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "keyholder" ) */
              } /* compare( x, xl, "kea" ) */
            case EQUAL:  return ( CSSM_WORDID_L ) ;
            case GREATER:
              switch ( compare( x, xl, "login" ) ) {
              case LESSER:
                switch ( compare( x, xl, "le" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_LE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "le" ) */
              case EQUAL:  return ( CSSM_WORDID_LOGIN ) ;
              case GREATER:
                switch ( compare( x, xl, "login-name" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_LOGIN_NAME ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "login-name" ) */
              } /* compare( x, xl, "login" ) */
            } /* compare( x, xl, "l" ) */
          case EQUAL:  return ( CSSM_WORDID_MAC ) ;
          case GREATER:
            switch ( compare( x, xl, "md5" ) ) {
            case LESSER:
              switch ( compare( x, xl, "md2withrsa" ) ) {
              case LESSER:
                switch ( compare( x, xl, "md2" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_MD2 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "md2" ) */
              case EQUAL:  return ( CSSM_WORDID_MD2WITHRSA ) ;
              case GREATER:
                switch ( compare( x, xl, "md4" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_MD4 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "md4" ) */
              } /* compare( x, xl, "md2withrsa" ) */
            case EQUAL:  return ( CSSM_WORDID_MD5 ) ;
            case GREATER:
              switch ( compare( x, xl, "n" ) ) {
              case LESSER:
                switch ( compare( x, xl, "md5withrsa" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_MD5WITHRSA ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "md5withrsa" ) */
              case EQUAL:  return ( CSSM_WORDID_N ) ;
              case GREATER:
                switch ( compare( x, xl, "name" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_NAME ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "name" ) */
              } /* compare( x, xl, "n" ) */
            } /* compare( x, xl, "md5" ) */
          } /* compare( x, xl, "mac" ) */
        } /* compare( x, xl, "issuer-info" ) */
      } /* compare( x, xl, "e" ) */
    case EQUAL:  return ( CSSM_WORDID_NDR ) ;
    case GREATER:
      switch ( compare( x, xl, "rsa-pkcs-md5" ) ) {
      case LESSER:
        switch ( compare( x, xl, "prompted-password" ) ) {
        case LESSER:
          switch ( compare( x, xl, "owner" ) ) {
          case LESSER:
            switch ( compare( x, xl, "numeric" ) ) {
            case LESSER:
              switch ( compare( x, xl, "not-before" ) ) {
              case LESSER:
                switch ( compare( x, xl, "not-after" ) ) {
                case LESSER:
                  switch ( compare( x, xl, "nhash" ) ) {
                  case LESSER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  case EQUAL:  return ( CSSM_WORDID_NHASH ) ;
                  case GREATER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  } /* compare( x, xl, "nhash" ) */
                case EQUAL:  return ( CSSM_WORDID_NOT_AFTER ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "not-after" ) */
              case EQUAL:  return ( CSSM_WORDID_NOT_BEFORE ) ;
              case GREATER:
                switch ( compare( x, xl, "null" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_NULL ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "null" ) */
              } /* compare( x, xl, "not-before" ) */
            case EQUAL:  return ( CSSM_WORDID_NUMERIC ) ;
            case GREATER:
              switch ( compare( x, xl, "one-time" ) ) {
              case LESSER:
                switch ( compare( x, xl, "object-hash" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_OBJECT_HASH ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "object-hash" ) */
              case EQUAL:  return ( CSSM_WORDID_ONE_TIME ) ;
              case GREATER:
                switch ( compare( x, xl, "online" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_ONLINE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "online" ) */
              } /* compare( x, xl, "one-time" ) */
            } /* compare( x, xl, "numeric" ) */
          case EQUAL:  return ( CSSM_WORDID_OWNER ) ;
          case GREATER:
            switch ( compare( x, xl, "pgp" ) ) {
            case LESSER:
              switch ( compare( x, xl, "pam-name" ) ) {
              case LESSER:
                switch ( compare( x, xl, "p" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_P ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "p" ) */
              case EQUAL:  return ( CSSM_WORDID_PAM_NAME ) ;
              case GREATER:
                switch ( compare( x, xl, "password" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PASSWORD ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "password" ) */
              } /* compare( x, xl, "pam-name" ) */
            case EQUAL:  return ( CSSM_WORDID_PGP ) ;
            case GREATER:
              switch ( compare( x, xl, "private-key" ) ) {
              case LESSER:
                switch ( compare( x, xl, "prefix" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PREFIX ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "prefix" ) */
              case EQUAL:  return ( CSSM_WORDID_PRIVATE_KEY ) ;
              case GREATER:
                switch ( compare( x, xl, "prompted-biometric" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PROMPTED_BIOMETRIC ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "prompted-biometric" ) */
              } /* compare( x, xl, "private-key" ) */
            } /* compare( x, xl, "pgp" ) */
          } /* compare( x, xl, "owner" ) */
        case EQUAL:  return ( CSSM_WORDID_PROMPTED_PASSWORD ) ;
        case GREATER:
          switch ( compare( x, xl, "range" ) ) {
          case LESSER:
            switch ( compare( x, xl, "protected-pin" ) ) {
            case LESSER:
              switch ( compare( x, xl, "protected-biometric" ) ) {
              case LESSER:
                switch ( compare( x, xl, "propagate" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PROPAGATE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "propagate" ) */
              case EQUAL:  return ( CSSM_WORDID_PROTECTED_BIOMETRIC ) ;
              case GREATER:
                switch ( compare( x, xl, "protected-password" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PROTECTED_PASSWORD ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "protected-password" ) */
              } /* compare( x, xl, "protected-biometric" ) */
            case EQUAL:  return ( CSSM_WORDID_PROTECTED_PIN ) ;
            case GREATER:
              switch ( compare( x, xl, "public-key-from-cert" ) ) {
              case LESSER:
                switch ( compare( x, xl, "public-key" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_PUBLIC_KEY ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "public-key" ) */
              case EQUAL:  return ( CSSM_WORDID_PUBLIC_KEY_FROM_CERT ) ;
              case GREATER:
                switch ( compare( x, xl, "q" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_Q ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "q" ) */
              } /* compare( x, xl, "public-key-from-cert" ) */
            } /* compare( x, xl, "protected-pin" ) */
          case EQUAL:  return ( CSSM_WORDID_RANGE ) ;
          case GREATER:
            switch ( compare( x, xl, "ripemd160" ) ) {
            case LESSER:
              switch ( compare( x, xl, "ripemac" ) ) {
              case LESSER:
                switch ( compare( x, xl, "reval" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_REVAL ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "reval" ) */
              case EQUAL:  return ( CSSM_WORDID_RIPEMAC ) ;
              case GREATER:
                switch ( compare( x, xl, "ripemd" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_RIPEMD ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "ripemd" ) */
              } /* compare( x, xl, "ripemac" ) */
            case EQUAL:  return ( CSSM_WORDID_RIPEMD160 ) ;
            case GREATER:
              switch ( compare( x, xl, "rsa-iso9796" ) ) {
              case LESSER:
                switch ( compare( x, xl, "rsa" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_RSA ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "rsa" ) */
              case EQUAL:  return ( CSSM_WORDID_RSA_ISO9796 ) ;
              case GREATER:
                switch ( compare( x, xl, "rsa-pkcs" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_RSA_PKCS ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "rsa-pkcs" ) */
              } /* compare( x, xl, "rsa-iso9796" ) */
            } /* compare( x, xl, "ripemd160" ) */
          } /* compare( x, xl, "range" ) */
        } /* compare( x, xl, "prompted-password" ) */
      case EQUAL:  return ( CSSM_WORDID_RSA_PKCS_MD5 ) ;
      case GREATER:
        switch ( compare( x, xl, "signed-nonce" ) ) {
        case LESSER:
          switch ( compare( x, xl, "set" ) ) {
          case LESSER:
            switch ( compare( x, xl, "rsa-pkcs1-sig" ) ) {
            case LESSER:
              switch ( compare( x, xl, "rsa-pkcs1-md5" ) ) {
              case LESSER:
                switch ( compare( x, xl, "rsa-pkcs1" ) ) {
                case LESSER:
                  switch ( compare( x, xl, "rsa-pkcs-sha1" ) ) {
                  case LESSER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  case EQUAL:  return ( CSSM_WORDID_RSA_PKCS_SHA1 ) ;
                  case GREATER:
                    return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                  } /* compare( x, xl, "rsa-pkcs-sha1" ) */
                case EQUAL:  return ( CSSM_WORDID_RSA_PKCS1 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "rsa-pkcs1" ) */
              case EQUAL:  return ( CSSM_WORDID_RSA_PKCS1_MD5 ) ;
              case GREATER:
                switch ( compare( x, xl, "rsa-pkcs1-sha1" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_RSA_PKCS1_SHA1 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "rsa-pkcs1-sha1" ) */
              } /* compare( x, xl, "rsa-pkcs1-md5" ) */
            case EQUAL:  return ( CSSM_WORDID_RSA_PKCS1_SIG ) ;
            case GREATER:
              switch ( compare( x, xl, "sdsiv1" ) ) {
              case LESSER:
                switch ( compare( x, xl, "rsa-raw" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_RSA_RAW ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "rsa-raw" ) */
              case EQUAL:  return ( CSSM_WORDID_SDSIV1 ) ;
              case GREATER:
                switch ( compare( x, xl, "sequence" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SEQUENCE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "sequence" ) */
              } /* compare( x, xl, "sdsiv1" ) */
            } /* compare( x, xl, "rsa-pkcs1-sig" ) */
          case EQUAL:  return ( CSSM_WORDID_SET ) ;
          case GREATER:
            switch ( compare( x, xl, "sha1withecdsa" ) ) {
            case LESSER:
              switch ( compare( x, xl, "sha1" ) ) {
              case LESSER:
                switch ( compare( x, xl, "sexpr" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SEXPR ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "sexpr" ) */
              case EQUAL:  return ( CSSM_WORDID_SHA1 ) ;
              case GREATER:
                switch ( compare( x, xl, "sha1withdsa" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SHA1WITHDSA ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "sha1withdsa" ) */
              } /* compare( x, xl, "sha1" ) */
            case EQUAL:  return ( CSSM_WORDID_SHA1WITHECDSA ) ;
            case GREATER:
              switch ( compare( x, xl, "sign" ) ) {
              case LESSER:
                switch ( compare( x, xl, "sha1withrsa" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SHA1WITHRSA ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "sha1withrsa" ) */
              case EQUAL:  return ( CSSM_WORDID_SIGN ) ;
              case GREATER:
                switch ( compare( x, xl, "signature" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SIGNATURE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "signature" ) */
              } /* compare( x, xl, "sign" ) */
            } /* compare( x, xl, "sha1withecdsa" ) */
          } /* compare( x, xl, "set" ) */
        case EQUAL:  return ( CSSM_WORDID_SIGNED_NONCE ) ;
        case GREATER:
          switch ( compare( x, xl, "uri" ) ) {
          case LESSER:
            switch ( compare( x, xl, "subject-info" ) ) {
            case LESSER:
              switch ( compare( x, xl, "spki" ) ) {
              case LESSER:
                switch ( compare( x, xl, "signed-secret" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SIGNED_SECRET ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "signed-secret" ) */
              case EQUAL:  return ( CSSM_WORDID_SPKI ) ;
              case GREATER:
                switch ( compare( x, xl, "subject" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_SUBJECT ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "subject" ) */
              } /* compare( x, xl, "spki" ) */
            case EQUAL:  return ( CSSM_WORDID_SUBJECT_INFO ) ;
            case GREATER:
              switch ( compare( x, xl, "threshold" ) ) {
              case LESSER:
                switch ( compare( x, xl, "tag" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_TAG ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "tag" ) */
              case EQUAL:  return ( CSSM_WORDID_THRESHOLD ) ;
              case GREATER:
                switch ( compare( x, xl, "time" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_TIME ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "time" ) */
              } /* compare( x, xl, "threshold" ) */
            } /* compare( x, xl, "subject-info" ) */
          case EQUAL:  return ( CSSM_WORDID_URI ) ;
          case GREATER:
            switch ( compare( x, xl, "x509v1" ) ) {
            case LESSER:
              switch ( compare( x, xl, "version" ) ) {
              case LESSER:
                switch ( compare( x, xl, "valid" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_VALID ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "valid" ) */
              case EQUAL:  return ( CSSM_WORDID_VERSION ) ;
              case GREATER:
                switch ( compare( x, xl, "x509-attribute" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_X509_ATTRIBUTE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "x509-attribute" ) */
              } /* compare( x, xl, "version" ) */
            case EQUAL:  return ( CSSM_WORDID_X509V1 ) ;
            case GREATER:
              switch ( compare( x, xl, "x509v3" ) ) {
              case LESSER:
                switch ( compare( x, xl, "x509v2" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_X509V2 ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "x509v2" ) */
              case EQUAL:  return ( CSSM_WORDID_X509V3 ) ;
              case GREATER:
                switch ( compare( x, xl, "x9-attribute" ) ) {
                case LESSER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                case EQUAL:  return ( CSSM_WORDID_X9_ATTRIBUTE ) ;
                case GREATER:
                  return ( CSSM_WORDID__UNK_ ) ;   /* undefined */
                } /* compare( x, xl, "x9-attribute" ) */
              } /* compare( x, xl, "x509v3" ) */
            } /* compare( x, xl, "x509v1" ) */
          } /* compare( x, xl, "uri" ) */
        } /* compare( x, xl, "signed-nonce" ) */
      } /* compare( x, xl, "rsa-pkcs-md5" ) */
    } /* compare( x, xl, "ndr" ) */
  return ( CSSM_WORDID__UNK_ ) ;  /* needed by some compilers */
} /* lookup */

#ifndef NULL
#define NULL ( (void *) 0 )
#endif

int clookup( CSSM_DATA *d )
{
  if (d == NULL) return ( CSSM_WORDID__UNK_ ) ;
  return ( lookup( d->Data, d->Length ) ) ;
} /* clookup */
