/***************************************************************************/
/* compare.h                                                               */
/*                                                                         */
/* Function definition and comparison values for the string compare fcn.   */
/***************************************************************************/

#if !defined( __COMPARE_H__ )
#define __COMPARE_H__

#include "cssmtype.h"

#define EQUAL (0)
#define LESSER (1)
#define GREATER (2)
#define INCOMPARABLE (3)

/***************************************************************************/
/* compare                                                                 */
/*                                                                         */
/* Compare string a, of a given length, to the \0 terminated string b.     */
/***************************************************************************/

int compare( uint8 *a, int a_lth, char *b ) ;

/***************************************************************************/
/* compare2                                                                */
/*                                                                         */
/* Compare two strings, each without \0 termination.                       */
/***************************************************************************/

int compare2( uint8 *a, int a_lth , uint8 *b, int b_lth ) ;

/***************************************************************************/
/* compare3                                                                */
/*                                                                         */
/* Compare two binary unsigned right-justified strings.                    */
/***************************************************************************/

int compare3( uint8 *a, int a_lth , uint8 *b, int b_lth ) ;

/***************************************************************************/
/* compare4                                                                */
/*                                                                         */
/* Compare two signed ascii numeric strings.                               */
/***************************************************************************/

int compare4( uint8 *a, int a_lth , uint8 *b, int b_lth ) ;

#endif /* __COMPARE_H__ */
