/*-----------------------------------------------------------------------
 * File: KEYUTIL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _KEYUTIL_H_
#define _KEYUTIL_H_



/* CSSM includes */
#include "cssm.h"
#include "cssmspi.h"
#include "guids.h"
#include "cssmport.h"
#include "cssmutil.h"
#include <cssmMemTrack.h>

CSSM_RETURN PKListTOCssmKey(CSSM_CSP_HANDLE CSPHandle,
                            CSSM_LIST *PKList, 
                            CSSM_KEY_PTR keyptr);

CSSM_RETURN ObtainEffectiveKeySize (CSSM_KEY_PTR Key,
                                    uint32 *EffKeySize);

CSSM_RETURN RSAKeyListToCssmKey(CSSM_CSP_HANDLE CSPHandle,
                                CSSM_LIST *keylist, 
                                CSSM_KEY_PTR keyptr);

CSSM_RETURN DSAKeyListToCssmKey(CSSM_CSP_HANDLE CSPHandle,
                                CSSM_LIST *keylist, 
                                CSSM_KEY_PTR keyptr);

CSSM_RETURN CssmKeyToSexp(CSSM_KEY_PTR keyptr,
                          CSSM_LIST_PTR KeyAsList,
                          CSSM_DATA *result);

CSSM_RETURN AddKeyToPrincipal(uint8 *Sexp,
							  CSSM_KEY_PTR keyptr,
							  CSSM_LIST_PTR result);
#endif /* _KEYUTIL_H_*/
