/***************************************************************************/
/* strread.h                                                               */
/*                                                                         */
/* Define the structure and routines for reading from an in-memory string. */
/***************************************************************************/

#ifndef _STRREAD_H_
#define _STRREAD_H_


typedef struct {
  unsigned char * top ;         /* top of the block */
  unsigned char * cur ;         /* current position */
  unsigned char * end ;         /* byte after end of the block */
} Sreader, *pSreader ;

#define STRR_LOOK( x )   *((x)->cur) /* look at current character */
#define STRR_READ( x )   *((x)->cur++) /* take current character */
#define STRR_MORE( x )   (((x)->cur) < ((x)->end)) /* test for EOF */
#define STRR_RESET( x )  { (x)->cur = (x)->top ; } /* back to the beginning */
#define STRR_INIT( s, buf, lth ) s.end = lth + (s.top = s.cur = buf) ;

#endif /* _STRREAD_H_ */
