/*-----------------------------------------------------------------------
 * File: CONTEXT.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

 

#ifndef CONTEXT_H
#define CONTEXT_H

#ifdef __cplusplus
extern "C"
{
#endif
#include "internal.h"

CSSM_RETURN CSSMAPI
CSSM_CHALLENGE_CALLBACK_API_PROXY(const CSSM_LIST *Challenge,
                                  CSSM_SAMPLEGROUP_PTR Response,
                                  void *CallerCtx,
                                  const CSSM_MEMORY_FUNCS *MemFuncs);
CSSM_RETURN CSSMAPI
cssm_ReplaceCssmProxyWithAppCallback(cssm_INTERNAL_CONTEXT_PTR TempContext,
                               uint32 Number,
                               CSSM_CONTEXT_ATTRIBUTE_PTR Attributes);
CSSM_RETURN CSSMAPI
cssm_ReplaceAppCallbacksWithCssmProxy(cssm_INTERNAL_CONTEXT_PTR TempContext,
                               uint32 Number,
                               CSSM_CONTEXT_ATTRIBUTE_PTR Attributes);

CSSM_RETURN CSSMAPI
cssm_CreateContext(CSSM_CSP_HANDLE CSPHandle,
                   CSSM_CONTEXT_TYPE Class, 
                   CSSM_ALGORITHMS AlgorithmID,
                   CSSM_CONTEXT_PTR *Context);

CSSM_RETURN CSSMAPI
cssm_InsertContext(CSSM_CONTEXT_PTR Context, 
                   CSSM_CSP_HANDLE CSPHandle, 
                   CSSM_CC_HANDLE *pCCHandle);


CSSM_RETURN CSSMAPI
cssm_SaveContextClone(CSSM_CSP_HANDLE CSPHandle,
                      cssm_INTERNAL_CONTEXT_PTR InternalCtx,
                      CSSM_CC_HANDLE CCHandle,
                      cssm_INTERNAL_CONTEXT_PTR *ContextList);

#ifdef VMS
#define cssm_FreeContext cssmint_FreeContext
#define cssm_DeleteContext cssmint_DeleteContext
#endif

CSSM_RETURN CSSMAPI
cssm_DeleteContext(cssm_INTERNAL_ATTACH_LIST_PTR AttachRecord,
                   cssm_INTERNAL_CONTEXT_PTR *ContextRecord);

CSSM_RETURN CSSMAPI
cssm_FreeContext(CSSM_CONTEXT_PTR *Context, 
                 CSSM_FREE free_func, 
                 void *mem_ref);


CSSM_RETURN CSSMAPI
cssm_AssignContext(CSSM_CC_HANDLE CCHandle, 
                   const CSSM_CONTEXT *Context);


CSSM_RETURN CSSMAPI
cssm_DuplicateContext(const CSSM_CONTEXT *Context,                   
                      CSSM_MALLOC malloc_func, 
                      CSSM_FREE free_func,
                      void *mem_ref,
                      cssm_INTERNAL_CONTEXT_PTR TempInternalContext,
                      CSSM_CONTEXT_PTR *DuplicateContext);

CSSM_RETURN CSSMAPI
cssm_UpdateContext(CSSM_CONTEXT_PTR Context, 
                   const CSSM_CONTEXT_ATTRIBUTE *Attribute);


CSSM_RETURN CSSMAPI
cssm_CreateAttribute(CSSM_CONTEXT_ATTRIBUTE_PTR *Attributes,
                     uint32 NumberAttributes);

CSSM_RETURN CSSMAPI
cssm_DelContextAttr(CSSM_CONTEXT_PTR Context, 
                    const CSSM_CONTEXT_ATTRIBUTE *Attribute);

CSSM_RETURN CSSMAPI
cssm_AddAttribute(CSSM_CONTEXT_ATTRIBUTE_PTR Attributes,
                  CSSM_ATTRIBUTE_TYPE type,
                  void *Data);

CSSM_RETURN CSSMAPI
cssm_UpdateAlgParamContextAttributes(CSSM_CONTEXT_PTR Context,
                                     uint32 NumberAttributes,
                                     const CSSM_CONTEXT_ATTRIBUTE *ContextAttributes);

CSSM_BOOL CSSMAPI
cssm_IsBadAccessCredentialsPtr (const CSSM_ACCESS_CREDENTIALS *Credentials);

CSSM_BOOL CSSMAPI
cssm_IsBadCryptoKeyPtr(const CSSM_KEY *Key);

CSSM_BOOL CSSMAPI
cssm_IsBadCryptoDataPtr(const CSSM_CRYPTO_DATA *Data);


#ifdef __cplusplus
}
#endif

#endif
