/*-----------------------------------------------------------------------
 * File: CONVERT.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */


#ifndef __MDSU_CONVERT_H__
#define __MDSU_CONVERT_H__

#ifndef _CSSMTYPE_H
#error cssmtype.h must be included before this file
#endif

#define _MDSU_PRINTABLE_GUID_LENGTH     ( 40 )
#define _MDSU_PRINTABLE_VERSION_LENGTH  ( 8 )

#if defined (__arch64__)
#define GUID_FORMAT_STRING "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}"
#else
#define GUID_FORMAT_STRING "{%08lx-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}"
#endif

CSSM_RETURN _MDSU_GetPrintableVersion( const CSSM_VERSION *pVersion,
                                       char *PrintableVersion );

CSSM_RETURN _MDSU_GetStructuredVersion( const char *PrintableVersion,
                                        CSSM_VERSION *pVersion );

CSSM_RETURN _MDSU_GetPrintableGUID( const CSSM_GUID *pGUID,
                                    char *PrintableGUID );

CSSM_RETURN _MDSU_GetStructuredGUID( const char *PrintableGUID,
                                     CSSM_GUID *pGUID );

#endif /* ifndef __MDSU_CONVERT_H__ */
