/*-----------------------------------------------------------------------
 * File: INSTALLDEFS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef __INSTALLDEFS_H
#define __INSTALLDEFS_H

typedef enum INSTALL_ACTION
{
	INSTALL_ACTION_INSTALL,
	INSTALL_ACTION_REFRESH,
	INSTALL_ACTION_UNINSTALL
} INSTALL_ACTION;

typedef struct _install_error
{
	CSSM_RETURN ErrorCode;
	CSSM_STRING ErrorString;
}
INSTALL_ERROR;

#define INSTALLERR_BASE				( 0x80000000 )
#define INSTALLERR_NO_DEVICE_SLOTS	( INSTALLERR_BASE + 1 )

/* Name of the installation entry point */
#define INSTALL_ENTRY_NAME			RegisterCDSAModule
#define INSTALL_ENTRY_NAME_STRING	"RegisterCDSAModule"

/* The entry point in the module must have this definition */
CSSM_RETURN CSSMAPI INSTALL_ENTRY_NAME(
						const char *szModuleName,
						const char *szSearchPath,
						CSSM_DATA *pCredential,
						INSTALL_ACTION Action,
						INSTALL_ERROR *pError );

/* Pointer type to the above function */
typedef CSSM_RETURN (CSSMAPI *INSTALL_ENTRY_PTR) (
						const char *szModuleName,
						const char *szSearchPath,
						CSSM_DATA *pCredential,
						INSTALL_ACTION Action,
						INSTALL_ERROR *pError );

#endif /* ifndef __INSTALDEFS_H__ */
