/*-----------------------------------------------------------------------
 * File: CSSMACF.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Function declarations for the Auth Compute module. The CSSM_DEFINE_FUNC
 * macro must be defined by the file that includes this header.
 */

#ifndef CSSM_DEFINE_FUNCTION
#error "The CSSM_DEFINE_FUNCTION(name,params) macro must be defined!"
#endif

CSSM_DEFINE_FUNCTION( AuthCompute, ( 
						CSSM_AC_HANDLE ACHandle,
						const CSSM_TUPLEGROUP *BaseAuthorizations,
						const CSSM_TUPLEGROUP *Credentials,
						uint32 NumberOfRequestors,
						const CSSM_LIST *Requestors,
						const CSSM_LIST *RequestedAuthorizationPeriod,
						const CSSM_LIST *RequestedAuthorization,
						CSSM_TUPLEGROUP_PTR AuthorizationResult ) );

CSSM_DEFINE_FUNCTION( PassThrough, (
				 		CSSM_AC_HANDLE ACHandle,
						CSSM_TP_HANDLE TPHandle, 
						CSSM_CL_HANDLE CLHandle, 
						CSSM_CC_HANDLE CCHandle, 
						const CSSM_DL_DB_LIST *DBList, 
						uint32 PassThroughId,
						const void *InputParams,
						void **OutputParams ) );
