/*-----------------------------------------------------------------------
 * File: CSSMACI.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _CSSMACI_H
#define _CSSMACI_H    

#ifdef __cplusplus
extern "C" {
#endif

/* Calling convention for AC SPIs */
#define CSSMACI CSSMAPI 

/* Defining a function pointer type for each SPI function. The pointer types 
 * are named _CSSM_ACSPI_XXX_PTR, where XXX is the name of the SPI.
 */
typedef CSSM_RETURN (CSSMACI *_CSSM_ACSPI_AuthCompute_PTR )(
                        CSSM_AC_HANDLE ACHandle,
                        const CSSM_TUPLEGROUP *BaseAuthorizations,
                        const CSSM_TUPLEGROUP *Credentials,
                        uint32 NumberOfRequestors,
                        const CSSM_LIST *Requestors,
                        const CSSM_LIST *RequestedAuthorizationPeriod,
                        const CSSM_LIST *RequestedAuthorization,
                        CSSM_TUPLEGROUP_PTR AuthorizationResult );

typedef CSSM_RETURN (CSSMACI *_CSSM_ACSPI_PassThrough_PTR )(
                        CSSM_AC_HANDLE ACHandle,
                        CSSM_TP_HANDLE TPHandle,
                        CSSM_CL_HANDLE CLHandle,
                        CSSM_CC_HANDLE CCHandle,
                        const CSSM_DL_DB_LIST *DBList,
                        uint32 PassThroughId,
                        const void *InputParams,
                        void **OutputParams );


/* Defining a function pointer interface table for the SPI.
 */
typedef struct cssm_spi_ac_funcs {
    _CSSM_ACSPI_AuthCompute_PTR     AuthCompute;
    _CSSM_ACSPI_PassThrough_PTR     PassThrough;
} CSSM_SPI_AC_FUNCS, *CSSM_SPI_AC_FUNCS_PTR;

#ifdef __cplusplus
}
#endif

#endif /* ifndef _CSSMACI_H */
