/*-----------------------------------------------------------------------
 * File: CSSMSPIF.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Function declarations for the generic SPI functions defined in the
 * CDSA MSA document.
 */

#ifndef CSSM_DEFINE_FUNCTION
#error "The CSSM_DEFINE_FUNCTION(name,params) macro must be defined!"
#endif

CSSM_DEFINE_FUNCTION( SPI_ModuleLoad, (
						const CSSM_GUID *CssmGuid,
						const CSSM_GUID *ModuleGuid,
						CSSM_SPI_ModuleEventHandler CssmNotifyCallback,
						void* CssmNotifyCallbackCtx ) );

CSSM_DEFINE_FUNCTION( SPI_ModuleUnload, (
						const CSSM_GUID *CssmGuid,
						const CSSM_GUID *ModuleGuid, 
						CSSM_SPI_ModuleEventHandler CssmNotifyCallback,
						void* CssmNotifyCallbackCtx ) );

CSSM_DEFINE_FUNCTION( SPI_ModuleAttach, (
						const CSSM_GUID *ModuleGuid,
						const CSSM_VERSION *Version, 
						uint32 SubserviceID,
						CSSM_SERVICE_TYPE SubServiceType, 
						CSSM_ATTACH_FLAGS AttachFlags,
						CSSM_MODULE_HANDLE ModuleHandle, 
						CSSM_KEY_HIERARCHY KeyHierarchy,
						const CSSM_GUID *CssmGuid,
						const CSSM_GUID *ModuleManagerGuid,
						const CSSM_GUID *CallerGuid,
						const CSSM_UPCALLS *Upcalls,  
						CSSM_MODULE_FUNCS_PTR *FuncTbl ) );

CSSM_DEFINE_FUNCTION( SPI_ModuleDetach, (
						CSSM_MODULE_HANDLE ModuleHandle ) );

