/*-----------------------------------------------------------------------
 * File: MDS_DBFUNCS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#include "mds_shim.h"
#include "cssmtype.h"

#ifndef MDS_DBFUNCS_H
#define MDS_DBFUNCS_H

#ifdef __cplusplus
extern "C" {
#endif

CSSM_RETURN
mds_GetObjectRecord ( CSSM_DL_DB_HANDLE hDLDB,
                      const CSSM_GUID *Guid,
                      MDS_OBJECT_RECORD_PTR Record,
                      CSSM_DB_ATTRIBUTE_DATA_PTR ObjectAttributes );

CSSM_RETURN 
mds_GetRecordByGuid( CSSM_DL_DB_HANDLE hDLDB,
                     const CSSM_GUID *guid,
                     CSSM_DB_RECORDTYPE RecordType,
                     uint32 NumAttributes,
                     CSSM_HANDLE_PTR ResultsHandle,
                     CSSM_BOOL *EndOfDataStore,
                     CSSM_DB_ATTRIBUTE_DATA *OutputAttributeData );

CSSM_RETURN
mds_GetRecord( CSSM_DL_DB_HANDLE hDLDB,
               CSSM_QUERY Query,
               CSSM_DB_RECORDTYPE RecordType,
               uint32 NumAttributes,
               CSSM_HANDLE_PTR ResultsHandle,
               CSSM_BOOL *EndOfDataStore,
               CSSM_DB_ATTRIBUTE_DATA *OutputAttributeData );

CSSM_RETURN
mds_object_schema_GetAttributes( MDS_OBJECT_RECORD_PTR Record,
                                 CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes );

CSSM_RETURN
mds_object_schema_SetAttributes( CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes,
                                 CSSM_DATA Guid,
                                 CSSM_DATA Manifest,
                                 CSSM_DATA ModuleName,
                                 CSSM_DATA Path);

CSSM_RETURN
mds_InsertObjectRecord( CSSM_DL_DB_HANDLE hDLDB,
                        CSSM_GUID_PTR guid,
                        CSSM_DATA Manifest,
                        CSSM_DATA ModuleName,
                        CSSM_DATA Path);

CSSM_RETURN
mds_InsertRecord( CSSM_DL_DB_HANDLE hDLDB,
                  CSSM_DB_RECORDTYPE RecordType,
                  CSSM_DB_RECORD_ATTRIBUTE_DATA_PTR Attributes);

void CSSMAPI
mds_GUIDToStr ( const CSSM_GUID *GUID,
                char *ID );

CSSM_RETURN CSSMAPI 
mds_DeleteRecordByGuid( CSSM_DL_DB_HANDLE hDLDB,
                        const CSSM_GUID *guid,
                        CSSM_DB_RECORDTYPE RecordType);

#if defined (__arch64__)
#define GUID_FORMAT_STRING "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}"
#else
#define GUID_FORMAT_STRING "{%08lx-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}"
#endif

#ifdef __cplusplus
}
#endif

#endif /* MDS_DBFUNCS_H */
