/*-----------------------------------------------------------------------
 * File: DSS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

/* Module name: dss.h
   Data and private function declarations for DSA.
*/

#ifndef _EICL_DSS_INCLUDE_
#define _EICL_DSS_INCLUDE_


/***************************************************************/
/* DSA Encryption/Decryption declarations                      */
/***************************************************************/

#ifdef  _MSC_VER
#define DWORDSIZE     64
typedef unsigned __int64 EICLDWord;
#elif defined  (__arch64__)
#define DWORDSIZE     64
typedef unsigned long EICLDWord;
#endif

typedef struct {
	long	length;				/* number of EICLWords */
	EICLWord value[MODULUS];
} DSAInt;

typedef struct {
	long	length;
	EICLWord	*value;				/* number of words */
} DSAData;



#if defined(_MSC_VER) || defined(__arch64__)
#define LowWord(x)		( (EICLWord)(x) )
#define HighWord(x)		( (EICLWord)( ((x) >> WORDSIZE) & 0xffffffff ) )
#endif

#define WORDMASK ( ~(EICLWord)0 )

#ifdef __cplusplus
extern "C" {
#endif


void     __stdcall EICL_ModExp     (DSAData *a, DSAData *e, DSAData *n, DSAData *t);
void     __stdcall EICL_ModExpCRT  (DSAData *C, DSAData *dp, DSAData *dq,
						 			DSAData *p, DSAData *q, DSAData *coeff, DSAData *t);
void	__stdcall  EICL_ModExpBQH  (DSAData *a, DSAData *e, DSAData *n, DSAData *t);

EICLWord __stdcall N0Prime        (EICLWord n0);
void __stdcall    EICL_Add        (DSAData *a, DSAData *b, DSAData *t);
void __stdcall    EICL_Mul        (DSAData *a, DSAData *b, DSAData *t);
void __stdcall    EICL_ModMul     (DSAData *a, DSAData *b, DSAData *n, DSAData *t);

int  __stdcall    EICL_Compare    (DSAData *a, DSAData *b);
void __stdcall    EICL_ModAdd     (DSAData *a, DSAData *b, DSAData *n, DSAData *t);
void __stdcall    EICL_ModSub     (DSAData *a, DSAData *b, DSAData *n, DSAData *t);
void __stdcall    MontProduct    (EICLWord ModExpN0prime, DSAData ModExpModulus, 
								  DSAData *a, DSAInt *b, DSAData *t);
void __stdcall    MontSquare     (EICLWord ModExpN0prime, DSAData ModExpModulus,
								  DSAData *a, DSAData *t);
void __stdcall    EICL_Rem        (DSAData *a, DSAData *b, DSAData *r);
void __stdcall    DSA_Rem        (DSAData *a, DSAData *b, DSAInt *r);
void __stdcall    EICL_Subtract   (DSAData *t, DSAData *a);
void __stdcall    EICL_Padding0   (DSAData *a);

#ifdef __cplusplus
}
#endif


#endif      /* _EICL_DSS_INCLUDE_ */

