/*-----------------------------------------------------------------------
 * File: CALLOUTS.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef _CALLOUTS_H_
#define _CALLOUTS_H_

typedef struct isl_callout_data {
	long length;
	unsigned char *value;
} ISL_CALLOUT_DATA;

/* All callout functions assume data buffers have been pre-allocated */

/* 
 *	EISL_RetrieveSelfCheckKey returns the EISL_SelfCheck DSA key.
 */

int EISL_RetrieveSelfCheckKey(		
	ISL_CALLOUT_DATA *Name);
/*
 * EISL_RetrieveRootIssuerKey returns the DSA key that verifies the root certificate.
 */
int EISL_RetrieveRootIssuerKey(
	ISL_CALLOUT_DATA *Name);
/*
 *	EISL_RetreveRootIssueName returns the default X509 certificate "issuer" Name 
 *  exactly as found in the certificate. 
 */
int EISL_RetrieveRootIssuerName(
	ISL_CALLOUT_DATA *Name);
/*
 *	EISL_RetrieveSelfCheckSectionName returns the default section name in the self-check signature.
 */
void EISL_RetrieveSelfCheckSectionName(
	ISL_CALLOUT_DATA *Name);

/*
 *	EISL_RetrieveSelfCheckCredentialsSize returns the size of the buffer required for
 *	credentials. This size will be used to allocate the buffer for credentials buffer
 *	in EISL_RetrieveSelfCheckCredentials.
 */
void EISL_RetrieveSelfCheckCredentialsSize(
#ifdef VMS
        uint32 *Size);
#else
        unsigned int *Size);
#endif

/*
 *	EISL_RetrieveSelfCheckCredentials returns the credential buffer in Name and the 
 *  serach path for the modules in Path.
 */
void EISL_RetrieveSelfCheckCredentials(
	ISL_CALLOUT_DATA *Name,
	ISL_CALLOUT_DATA *Path);

#endif
