/*-----------------------------------------------------------------------
* File: CERTGEN.H
*
* Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
*-----------------------------------------------------------------------
*/
/*
* INTEL CONFIDENTIAL 
* This file, software, or program is supplied under the terms of a 
* license agreement or nondisclosure agreement with Intel Corporation 
* and may not be copied or disclosed except in accordance with the 
* terms of that agreement. This file, software, or program contains 
* copyrighted material and/or trade secret information of Intel 
* Corporation, and must be treated as such. Intel reserves all rights 
* in this material, except as the license agreement or nondisclosure 
* agreement specifically indicate. 
*/
/* 
* WARNING: EXPORT RESTRICTED. 
* This software listing contains cryptographic methods and technology. 
* It is export restricted by the Office of Defense Trade Controls, United 
* States Department of State and cannot be downloaded or otherwise 
* exported or re-exported (i) into (or to a national or resident of) Cuba, 
* Iraq, Libya, Yugoslavia, North Korea, Iran, Syria or any other country 
* to which the US has embargoed goods; or (ii) to anyone on the US 
* Treasury Department's list of Specially Designated Nationals or the US 
* Commerce Department's Table of Denial Orders. By downloading or using 
* this product, you are agreeing to the foregoing and you are representing 
* and warranting that you are not located in, under the control of, or a 
* national or resident of any such country or on any such list. 
*/

#ifndef CERTGEN_H
#define CERTGEN_H

#define UTC_TIME_LENGTH 14
#define GEN_TIME_LENGTH 16
#define FILENAME_MAXLEN 128
#define MAX_PASS_LEN 17 /* 16 char password */
#define SERIAL_FILENAME "certgen.ini"
#define DEFAULT_CONFIG_FILENAME "certgen.run"

CSSM_RETURN CertGen_Init(void);

CSSM_RETURN CertGen_UnInit(void);

CSSM_RETURN CreateCert(const CSSM_DATA * CertTemplateOrVendorCertDataPtr,
                       CSSM_BOOL VendorCert,
                       CSSM_BOOL SelfSigned,
                       CSSM_BOOL UseOldDSAOID,
                       uint32 Serial,
                       const CSSM_DATA * IssuerCertPtr,
                       uint32 KeySize, 
                       CSSM_ALGORITHMS KeyAlg,
                       uint8 *szNotBefore,
                       uint8 *szNotAfter,
                       char *subject_pass,
                       char *issuer_pass,
                       CSSM_DATA_PTR CertPtr);


CSSM_RETURN ParseTemplate(const CSSM_DATA * TemplatePtr,
                          CSSM_FIELD_PTR *FieldPtr,
                          uint32 *NumFields);


CSSM_RETURN CSSMKeyToSpki(CSSM_KEY_PTR CSSMKey, 
                          CSSM_X509_SUBJECT_PUBLIC_KEY_INFO_PTR spki_ptr);

#endif
