/*-----------------------------------------------------------------------
 * File: CREDUTIL.H
 *
 * Copyright (c) 1995-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */
/*
 * INTEL CONFIDENTIAL 
 * This file, software, or program is supplied under the terms of a 
 * license agreement or nondisclosure agreement with Intel Corporation 
 * and may not be copied or disclosed except in accordance with the 
 * terms of that agreement. This file, software, or program contains 
 * copyrighted material and/or trade secret information of Intel 
 * Corporation, and must be treated as such. Intel reserves all rights 
 * in this material, except as the license agreement or nondisclosure 
 * agreement specifically indicate. 
 */
/* 
 * WARNING: EXPORT RESTRICTED. 
 * This software listing contains cryptographic methods and technology. 
 * It is export restricted by the Office of Defense Trade Controls, United 
 * States Department of State and cannot be downloaded or otherwise 
 * exported or re-exported (i) into (or to a national or resident of) Cuba, 
 * Iraq, Libya, Yugoslavia, North Korea, Iran, Syria or any other country 
 * to which the US has embargoed goods; or (ii) to anyone on the US 
 * Treasury Department's list of Specially Designated Nationals or the US 
 * Commerce Department's Table of Denial Orders. By downloading or using 
 * this product, you are agreeing to the foregoing and you are representing 
 * and warranting that you are not located in, under the control of, or a 
 * national or resident of any such country or on any such list. 
 */

#ifndef __TEST_CREDUTIL_H__
#define __TEST_CREDUTIL_H__

#define CSSM_LEAN
#include "cssm.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _credutil_resource_control_context
{
	CSSM_RESOURCE_CONTROL_CONTEXT RCContext;
	CSSM_LIST_ELEMENT SubjectTypeElement;
	CSSM_LIST_ELEMENT PromptElement;
	CSSM_LIST_ELEMENT PasswordElement;
}
CREDUTIL_PASSWORD_RESOURCE_CONTROL_CONTEXT;

typedef struct _credutil_password_access_credential
{
	CSSM_ACCESS_CREDENTIALS AccessCred;
	CSSM_SAMPLE PasswordSample;
	CSSM_LIST_ELEMENT CredTypeElement;
	CSSM_LIST_ELEMENT PasswordElement;
}
CREDUTIL_PASSWORD_ACCESS_CREDENTIAL;

CSSM_ACCESS_CREDENTIALS* CSSMAPI CREDUTIL_CreatePasswordCredentials(
						CREDUTIL_PASSWORD_ACCESS_CREDENTIAL *pCredStruct,
						char *Password,
						CSSM_CHALLENGE_CALLBACK ChallengeCallback,
						void *ChallengeCallbackCtx );

CSSM_RESOURCE_CONTROL_CONTEXT* CSSMAPI CREDUTIL_CreatePasswordRCContext(
						CREDUTIL_PASSWORD_RESOURCE_CONTROL_CONTEXT *pRCStruct,
						char *Password,
						char *Prompt,
						CSSM_ACL_SUBJECT_CALLBACK SubjectCallback,
						void *SubjectCallbackCtx,
						CSSM_ACL_AUTHORIZATION_TAG *AuthTags,
						uint32 NumAuthTags,
						CSSM_ACCESS_CREDENTIALS *AccessCred );

#ifdef __cplusplus
}
#endif

#endif /* ifndef __TEST_CREDUTIL_H__ */
