/*-----------------------------------------------------------------------
 * File: MRMVERSION.H
 *
 * Copyright (c) 1998-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

// MRMVersion.h: interface for the CMRMVersion class.
//
// This file contains the class definition for the CMRMVersion class.
//  The CMRMVersion class implements a version object for use with
//  the operational representation of an MRM.
//
//////////////////////////////////////////////////////////////////////
#ifndef MRMVERSION_H
#define MRMVERSION_H

#include "mrm_defs.h"

//////////////////////////////////////////////////////////////////////
// Class description: CMRMVersion
//  Members:
//      mMinor(public)      
//          minor version number
//      mMajor(public)
//          major version number
//  Methods:
//      none
/////////////////////////////////////////////////////////////////////
class DllExport CMRMVersion  
{
public:
	// public members
    unsigned char mMinor;
	unsigned char mMajor;
	
	// constructors
    CMRMVersion(const CMRMVersion *version);
	CMRMVersion();
	~CMRMVersion();

};

#endif // !def MRMVERSION_H
