/*-----------------------------------------------------------------------
 * File: WF_PKAPI.H
 *
 * Copyright (c) 1998-2000 Intel Corporation. All rights reserved.
 *-----------------------------------------------------------------------
 */

#ifndef WF_PKAPI_H_
#define WF_PKAPI_H_

#ifdef WIN32
#pragma warning (disable:4201 4514 4214 4115)
#include <windows.h>
#pragma warning (default:4201 4214 4115)
#endif
#include "wf_pkdef.h"
#include "MRMVersion.h"
#include "wf_type.h"

#ifdef __cplusplus
extern "C" {
#endif


PK_ARCHIVE_PTR
mrm_pk_LoadArchive(WF_CONST_DATA Filename );

PK_ARCHIVE_PTR
mrm_pk_BuildArchiveFromFileimage(WF_CONST_DATA &Fileimage);

PK_STATUS
mrm_pk_RecycleArchive(PK_ARCHIVE_PTR pArchive );

PK_STATUS
mrm_pk_FindFile(PK_ARCHIVE_PTR pPKArchive,
                WF_CONST_DATA Filename,
                WF_CONST_DATA_PTR Filedata );

PK_ITERATOR_PTR
mrm_pk_CreateFileEnumerator(PK_ARCHIVE_PTR pPKArchive);

PK_STATUS
mrm_pk_GetNextFile(PK_ITERATOR_PTR pIterator,
                   WF_CONST_DATA_PTR Filename,
                   WF_CONST_DATA_PTR Filedata );

PK_STATUS
mrm_pk_RecycleFileEnumerator(PK_ITERATOR_PTR pIterator );


PK_NEW_ARCHIVE_PTR
mrm_pk_CreateNewArchive();

PK_STATUS
mrm_pk_AddFileToNewArchive(PK_NEW_ARCHIVE_PTR pNewArchive,
                           WF_CONST_DATA Filename,
                           WF_CONST_DATA Filedata );

WF_SIZE 
mrm_pk_GetSizeOfArchive(PK_NEW_ARCHIVE_PTR pNewArchive,
                        WF_CONST_DATA FilenameToWrite,
                        CMRMVersion *MRMVersion,
                        WF_GUID *AppID,
                        WF_GUID *ContextID,
                        WF_DATA *PrincipalID);

PK_STATUS
mrm_pk_WriteNewArchive(PK_NEW_ARCHIVE_PTR pNewArchive,
                       WF_CONST_DATA FilenameToWrite);

PK_STATUS
mrm_pk_WriteNewMRMArchive(PK_NEW_ARCHIVE_PTR pNewArchive,
                          WF_CONST_DATA FilenameToWrite,
                          CMRMVersion *MRMVersion,
                          WF_GUID *AppID,
                          WF_GUID *ContextID,
                          WF_DATA *PrincipalID);

PK_STATUS
mrm_pk_WriteNewMRMToBuffer(PK_NEW_ARCHIVE_PTR pNewArchive,
	    				   CMRMVersion *MRMVersion,
		    			   WF_GUID *AppID,
                           WF_GUID *ContextID,
                           WF_DATA *PrincipalID,
                           WF_CONST_DATA_PTR Buffer);

PK_STATUS
mrm_pk_RecycleNewArchive(PK_NEW_ARCHIVE_PTR	pNewArchive );


#ifdef __cplusplus
}
#endif
#endif
